/* 
   $B;^$K$D$$$F$$$k%3%9%H$,HsIi$G$"$k%0%i%U$N:GC;O)LdBj$r2r$/%W%m%0%i%`(B.
   $B%@%$%/%9%H%iK!$r<BAu(B. $B%G!<%?9=B$$K%R!<%W$rMQ$$$F$$$J$$$N$G(B,
   $B;~4VNL$O(BO(nm).
*/

#include <stdio.h>
#include <stdlib.h>
#define  INF   1000000
#define  ZERO  0.00001

struct edge{
  double  d;
  int     end1;
  int     end2;
}*E;

struct node{
  int nodenum;
  int edgenum;  
  struct node *next;
}*V;

struct cost{
  double d;
  int    prev;
}*label;

/*$BJQ?t(B*/
int  width,  /*drawgraph$B$G%0%i%U$rIA2h$9$k$H$-$K2#$KJB$V@aE@$N8D?t(B*/
     n,      /*$B%0%i%U$N@aE@?t(B*/
     m;      /*$B%0%i%U$N;^?t(B*/

/*$B4X?t(B*/
int findminnode(int *, int *);  /*$B:GC;O)$,7hDj$5$l$F$$$J$$@aE@$NFb;CDj%3%9%H$,:G>.$G$"$k@aE@$rJV$94X?t(B*/
void readin(void);              /*$B%G!<%?$NF~NO$N$?$a$N4X?t(B*/
void *malloc_e(size_t size);    /*$B%a%b%j3NJ]$N$?$a$N4X?t(B*/
void make_adjlist(void);        /*$B@\B3%j%9%H$r:n@.$9$k4X?t(B*/
void initialization(int *,int *,int *,int *);      /*$B=i4|2=$r9T$&4X?t(B*/

void main(void){ 
  int  i,
       source,      /*$B$3$NJQ?t$NCM$G$"$k@aE@$+$i$N:GC;O)$r5a$a$F$$$/(B.
                      $B%W%m%0%i%`Cf$G$O(B 0 $B$K@_Dj(B*/
       NumLeftNode, /*$B:GC;O)$,7hDj$5$l$F$$$J$$@aE@$N8D?t$r3JG<(B. $B$3$NCM$,(B0$B$K$J$k$H%W%m%0%i%`$O=*N;(B*/
       *nodestate,  /*$B@aE@$N>uBV$rI=$9(B.
		       1  $B;CDj%3%9%H$,(BINF$B0J30$K$J$C$F$$$k(B
		       0  $B;CDj%3%9%H$,(BINF
		      -1  $B:GC;O)$,5a$a$i$l$F$$$k(B*/
       *prev,       
       minnode;     /*$B;CDj%3%9%H$,:G>.$N$H$J$k@aE@HV9f$r3P$($k$?$a$NJQ?t(B*/
  struct node  *pt; 

  /*read an input data and memory allocation*/
  readin();

  /*memory allocation*/
  label = (struct cost *)malloc_e(n*sizeof(struct cost));
  nodestate = (int *)malloc_e(n*sizeof(int));
  prev = (int *)malloc_e(n*sizeof(int));

  /*construct an adjacent list*/
  make_adjlist();

  /*initialization*/
  initialization(prev,nodestate,&source,&NumLeftNode);
  
  while( NumLeftNode != 0 ){
    minnode = findminnode(nodestate,prev);
    nodestate[minnode] = -1;
    NumLeftNode--;

    for(pt=V[minnode].next ; pt!=0 ; pt=pt->next){
      if( nodestate[pt->nodenum] != -1 ){
	nodestate[pt->nodenum] = 1;
      }
      else{ continue; }
      
      if( label[pt->nodenum].d - (label[minnode].d + E[pt->edgenum].d) > ZERO ){
	label[pt->nodenum].d = label[minnode].d + E[pt->edgenum].d;
	label[pt->nodenum].prev = minnode;
      }
    }
  }

  for(i=0;i<n;i++){
    int pt;
    printf("node:%d\tcost:%.0f\t%d",i,label[i].d,i);
    for(pt=prev[i] ; pt!=-1 ; pt=prev[pt]){
      printf("<-%d",pt);
    }
    printf("\n");
  }
}

int findminnode(int *flag, int *prev){
  int i,nodenow = -1;
  double costnow = (double)INF;

  for(i=0;i<n;i++){
    if( flag[i] != 1 )  continue;
    if( label[i].d - costnow < ZERO ){
      nodenow = i;
      costnow = label[i].d;
    }
  }

  if( nodenow == -1 ){
    fprintf(stderr,"error in findminnode!!\n");
    exit(EXIT_FAILURE);
  }

  prev[nodenow] = label[nodenow].prev;
  return nodenow;
}


void readin(void){
  int i;

  fscanf(stdin,"%d %d %d ",&width,&n,&m);
  /*memory allocation for edge data*/
  E = (struct edge *)malloc_e(m*sizeof(struct edge));
  /*input the edge data*/
  for(i=0;i<m;i++)
    fscanf(stdin,"%lf %d %d",&E[i].d,&E[i].end1,&E[i].end2);
}


void *malloc_e( size_t size ) {
  void *s;
  if ( (s=malloc(size)) == NULL ) {
    fprintf( stderr, "malloc : Not enough memory.\n" );
    fprintf( stderr, " -> Try setting cslub to -1.\n" );
    fprintf( stderr, "    If it fails, then try memeff = 1.\n" );
    exit( EXIT_FAILURE );
  }
  return s;
}


void make_adjlist(void){
  int i;
  struct node  **curr,*new;

  V = (struct node *)malloc_e(n*sizeof(struct node));
  curr = (struct node **)malloc_e(n*sizeof(struct node *));
  for(i=0;i<n;i++){
    V[i].next = NULL;
    curr[i] = &V[i];
  }

  for(i=0;i<m;i++){
    new = (struct node *)malloc_e(sizeof(struct node));
    new->nodenum = E[i].end2;
    new->edgenum = i;
    new->next = NULL;
    curr[E[i].end1]->next = new;
    curr[E[i].end1] = new;
    new = (struct node *)malloc_e(sizeof(struct node));
    new->nodenum = E[i].end1;
    new->edgenum = i;
    new->next = NULL;
    curr[E[i].end2]->next = new;
    curr[E[i].end2] = new;
  }
}

void print_graph(void){
  int i;

  printf("begingraph\n");
  printf("width\t%d\n",width);
  printf("nodenum\t%d\n",n);
  printf("edgenum\t%d\n",m);
  printf("source\t0\n");
  printf("nodestart\t0\n");
  for(i=0;i<m;i++)
    printf("edge\t%.0f\t%d\t%d\n",E[i].d,E[i].end1,E[i].end2);
  printf("endgraph\n");
}

void initialization(int previous[], int state[], int *s, int *Num){
  int i;
  struct node  *pt;

  *s = 0;
  *Num = n - 1;
  for(i=0;i<n;i++){
    label[i].d = (double)INF;
    state[i] = 0;
  }

  previous[0] = -1;
  state[0] = -1;
  label[0].d = 0.0;

  for(pt=V[0].next ; pt!=NULL ; pt=pt->next){
    state[pt->nodenum] = 1;
    label[pt->nodenum].d = E[pt->edgenum].d;
    label[pt->nodenum].prev = 0;
  }
}

